SuperStrict
Framework brl.standardio
Import brl.glmax2d
Import brl.linkedlist
Import brl.Math
Import brl.Random
Import brl.Timer

SeedRnd(MilliSecs())

Global attackdist:Float=20
Global baseMaxHealth:Float=1000
Global baseHealSpeed:Float=.2
Global baseAttack:Float=.5
Global baseHealthAfterCap:Float=500
Global ratHealth:Float=100
Global animspeed:Float=8
Global mindist:Float=5
Global spawnrate:Int=300
Global difficulty:Float=3
Global speedfactor:Float=.3
Global levelupxp:Int=20
Global leveluptexty:Int=100000

Type TBase
	Global baselist:TList = CreateList()
	Field owner:TPlayer
	Field x:Float,y:Float
	Field health:Float
	
	Function Create:TBase(owner:TPlayer,x:Float,y:Float)
		Local b:TBase = New TBase
		b.owner = owner
		b.x = x
		b.y = y
		b.health = baseMaxHealth
		baselist.AddLast(b)
		Return b
	End Function
	
	Method getScore:Float(player:TPlayer)
		If (player=owner) Then Return 0
		Local ratct:Int=0
		Local dist:Float=0
		For Local r:TRat=EachIn TRat.ratlist
			If (r.player=player) Then
				ratct:+1
				dist:+getDist(r.x,r.y,x,y)
			EndIf
		Next
		Return 1/((dist/ratct)/(player.speed*speedfactor)+health/(baseAttack*ratct))
	End Method
	
	Method update()
		health:+baseHealSpeed
		If (health>baseMaxHealth) Then health=baseMaxHealth
		If (owner=TPlayer.player And Rand(0,Int(Float(spawnrate)*difficulty))=0) Then
			TRat.Create(owner,x,y)
		ElseIf (owner<>Null And Rand(0,spawnrate)=0) Then
			TRat.Create(owner,x,y)
		EndIf
	End Method
	Method draw()
		Local hcm:Float = health/baseMaxHealth
		If (owner=Null) Then
			SetColor(255*hcm,255*hcm,255*hcm)
		Else
			SetColor(owner.r*hcm,owner.g*hcm,owner.b*hcm)
		EndIf
		DrawOval(x-15,y-15,30,30)
	End Method
End Type

Type TPlayer
	Global playerlist:TList = CreateList()
	Global player:TPlayer
	Field x:Float,y:Float,changed:Int
	Field speed:Float,atk:Float,def:Float
	Field r:Int,g:Int,b:Int
	Field xp:Int,level:Int=1
	
	Function Create:TPlayer(speed:Float,atk:Float,def:Float,r:Int,g:Int,b:Int)
		Local p:TPlayer = New TPlayer
		p.speed = speed
		p.atk = atk
		p.def = def
		p.r = r
		p.g = g
		p.b = b
		playerlist.AddLast(p)
		Return p
	End Function
	
	Method update()
		If (xp>=levelupxp) Then
			xp:-levelupxp
			level=level+1
			speed:+.2
			If (Self = player)  Then
				leveluptexty=0
			EndIf
		EndIf
		If (Self=player) Then
			Local xn:Int,yn:Int
			xn = MouseX()
			yn = MouseY()
			If (xn=x And yn=y) Then
				changed=0
			Else
				changed=1
			EndIf
			x = xn
			y = yn
		Else
			Local bestscore:Float=-1
			Local bestbase:TBase=Null
			For Local base:TBase=EachIn TBase.baselist
				Local score:Float=base.getScore(Self)
				If (score>bestscore) Then
					bestscore=score
					bestbase=base
				EndIf
			Next
			If (Rand(0,120)=0) Then
				changed=1
			Else
				changed=0
			EndIf
			If (bestbase<>Null) Then
				x=bestbase.x
				y=bestbase.y
			EndIf
		EndIf
	End Method
End Type

Type TRat
	Global ratlist:TList = CreateList()
	Field player:TPlayer
	Field x:Float,y:Float,dx:Float,dy:Float,health:Float
	Field loop:Float,aspeed:Float
	Field lastdir:Float
	
	Function Create:TRat(player:TPlayer, x:Float, y:Float)
		Local r:TRat = New TRat
		r.player = player
		r.dx = Cos(Rand(0,360))*Rand(0,30)
		r.dy = Sin(Rand(0,360))*Rand(0,30)
		r.x = x+r.dx
		r.y = y+r.dy
		r.loop = Rand(0,180)
		r.aspeed = animspeed*(.8+Rnd()*.2)
		r.health = rathealth
		ratlist.AddLast(r)
		Return r
	End Function
	
	Method update()
		loop:+aspeed
		If (loop>=180) Then loop:-180
		If (getDist(x,y,player.x+dx,player.y+dy)>mindist) Then
			x :+ Cos(getDir())*player.speed*(Sin(loop)+.3)*speedfactor
			y :+ Sin(getDir())*player.speed*(Sin(loop)+.3)*speedfactor
		EndIf
		If (player.changed) Then
			dx = Cos(Rand(0,360))*Rand(0,30)
			dy = Sin(Rand(0,360))*Rand(0,30)
		EndIf
		Local attacks:Int=1
		For Local rat:TRat=EachIn TRat.ratlist
			If (attacks=1 And getDist(x,y,rat.x,rat.y)<attackdist And rat.player<>player) Then
				rat.health:-player.atk
				If (rat.health<=0 And rat.health>-1000) Then
					rat.health=-1001
					player.xp:+1
				EndIf
				attacks=0
			EndIf
		Next
		For Local base:TBase=EachIn TBase.baselist
			If (attacks=1 And getDist(x,y,base.x,base.y)<attackdist And base.owner<>player) Then
				base.health:-baseattack
				If (base.health<=0) Then
					base.health=baseHealthAfterCap
					base.owner=player
					player.xp:+5
				EndIf
				attacks=0
			EndIf
		Next
	End Method
	Method getDir:Float()
		Local difx:Float = player.x+dx-x
		Local dify:Float = player.y+dy-y
		Return ATan2(dify,difx)
	End Method
	Method removeIfDead()
		If (health<=0) Then ratlist.remove(Self)
	End Method
	Method draw()
		SetColor(player.r,player.g,player.b)
		DrawOval(x-1,y-1,3,3)
		If (getDist(x,y,player.x+dx,player.y+dy)>mindist) Then
			lastdir = getDir()
		Else
			lastdir:+Rand(-5,5)
		EndIf
		DrawOval(x-2-Cos(lastdir)*3,y-2-Sin(lastdir)*3,5,5)
		DrawLine(x,y,x-Cos(lastdir)*10,y-Sin(lastdir)*10)
	End Method
End Type

Function getDist:Float(x1:Float,y1:Float,x2:Float,y2:Float)
	Local x:Float=x2-x1
	Local y:Float=y2-y1
	Return Sqr(x*x+y*y)
End Function



Graphics(800,600)

While True
	game()
Wend

Function game()
	TPlayer.player = TPlayer.Create(1,1,1,0,0,255)
	Local enemy1:TPlayer = TPlayer.Create(1,1,1,255,0,0)
	Local enemy2:TPlayer = TPlayer.Create(1,1,1,0,255,0)
	Local enemy3:TPlayer = TPlayer.Create(1,1,1,255,255,0)
	
	TBase.Create(TPlayer.player,100,100)
	TBase.Create(enemy1,100,500)
	TBase.Create(enemy2,700,100)
	TBase.Create(enemy3,700,500)
	
	For Local i:Int = 1 To Rand(12,16)
		TBase.Create(Null,Rand(110,690),Rand(110,490))
	Next
	
	
	For Local i:Int = 1 To 5
		TRat.Create(TPlayer.player,10,10)
	Next
	
	For Local i:Int = 1 To 5
		TRat.Create(enemy1,10,590)
	Next
	For Local i:Int = 1 To 5
		TRat.Create(enemy2,790,10)
	Next
	For Local i:Int = 1 To 5
		TRat.Create(enemy3,790,590)
	Next
	
	Local gamerunning:Int=1
	Local outro:Int=0
	Local won:Int=0
	While gamerunning=1
		If (KeyHit(KEY_ESCAPE)) Then End
		Cls()
		
		If (won=0) Then
			won=checkWon()
		ElseIf (outro=0) Then
			TBase.baselist.clear()
			For Local r:TRat=EachIn TRat.ratlist
				If (r.player<>TPlayer.player) Then TRat.ratlist.remove(r)
			Next
			For Local i:Int = 1 To 5
				TRat.Create(TPlayer.player,TPlayer.player.x,TPlayer.player.y)
			Next
			TBase.Create(Null,420,440)
			outro=1
		EndIf
		If (outro=1)
			SetScale(10,10)
			If (won=1) Then
				DrawText("You Win!",50, 200)
			Else
				DrawText("You Loose!",50, 200)
			EndIf
			SetScale(5,5)
			DrawText("Restart:",50,400)
			SetScale(1,1)
			If (checkWon()=1) Then gamerunning=0
		EndIf
		
		For Local p:TPlayer=EachIn TPlayer.playerlist
			p.update()
		Next
		For Local b:TBase=EachIn TBase.baselist
			b.update()
			b.draw()
		Next
		For Local r:TRat=EachIn TRat.ratlist
			r.update()
			r.draw()
		Next
		For Local r:TRat=EachIn TRat.ratlist
			r.removeIfDead()
		Next 
		SetScale(10,10)
		DrawText("Level up!", 50, leveluptexty)
		leveluptexty:+7
		SetScale(1,1)
		SetColor(255,255,255)
		DrawText("Level: "+TPlayer.player.level,10,10)
		Flip(1)
	Wend
	
	TBase.baselist.clear()
	TPlayer.playerlist.clear()
	TRat.ratlist.clear()
End Function

Function checkWon:Int()
	Local playerbases:Int=0
	Local totalbases:Int=0
	For Local b:TBase=EachIn TBase.baselist
		If (b.owner=TPlayer.player) Then playerbases:+1
		totalbases:+1
	Next
	If (playerbases=0) Then Return -1
	If (playerbases=totalbases) Then Return 1
	Return 0
End Function