Framework brl.standardio
Import brl.glmax2d
Import brl.linkedlist
Import brl.Math
Import brl.Random
Import brl.Timer

SeedRnd(MilliSecs())

Global attD:Float=20
Global baseMaxHP:Float=1000
Global baseHealSpeed:Float=.2
Global baseAttack:Float=.5
Global baseHPAfterCap:Float=500
Global ratHP:Float=100
Global animspeed:Float=8
Global mindist:Float=5
Global spawnrate=300
Global difficulty:Float=3
Global speedfactor:Float=.3
Global levelupxp=20
Global leveluptexty=100000

Type TB
Global list:TList = CreateList()
Field owner:TP
Field x:Float,y:Float
Field HP:Float

Function Create:TB(owner:TP,x:Float,y:Float)
b:TB = New TB
b.owner = owner
b.x = x
b.y = y
b.HP = baseMaxHP
list.AddLast(b)
Return b
End Function

Method getScore:Float(player:TP)
If (player=owner) Return 0
ratct=0
dist:Float=0
For r:TR=EachIn TR.list
If (r.player=player)
ratct:+1
dist:+getDist(r.x,r.y,x,y)
EndIf
Next
Return 1/((dist/ratct)/(player.speed*speedfactor)+HP/(baseAttack*ratct))
End Method

Method up()
HP:+baseHealSpeed
If (HP>baseMaxHP) HP=baseMaxHP
If (owner=TP.player And Rand(0,Int(Float(spawnrate)*difficulty))=0)
TR.Create(owner,x,y)
ElseIf (owner<>Null And Rand(0,spawnrate)=0)
TR.Create(owner,x,y)
EndIf
End Method
Method dr()
hcm:Float = HP/baseMaxHP
If (owner=Null)
SetColor(255*hcm,255*hcm,255*hcm)
Else
SetColor(owner.r*hcm,owner.g*hcm,owner.b*hcm)
EndIf
DrawOval(x-15,y-15,30,30)
End Method
End Type

Type TP
Global list:TList = CreateList()
Global player:TP
Field x:Float,y:Float,changed
Field speed:Float,atk:Float,def:Float
Field r,g,b
Field xp,level=1

Function Create:TP(speed:Float,atk:Float,def:Float,r,g,b)
p:TP = New TP
p.speed = speed
p.atk = atk
p.def = def
p.r = r
p.g = g
p.b = b
list.AddLast(p)
Return p
End Function

Method up()
If (xp>=levelupxp)
xp:-levelupxp
level=level+1
speed:+.2
If (Self = player) 
leveluptexty=0
EndIf
EndIf
If (Self=player)
xn = MouseX()
yn = MouseY()
If (xn=x And yn=y)
changed=0
Else
changed=1
EndIf
x = xn
y = yn
Else
bestscore:Float=-1
besTB:TB=Null
For base:TB=EachIn TB.list
score:Float=base.getScore(Self)
If (score>bestscore)
bestscore=score
besTB=base
EndIf
Next
If (Rand(0,120)=0)
changed=1
Else
changed=0
EndIf
If (besTB<>Null)
x=besTB.x
y=besTB.y
EndIf
EndIf
End Method
End Type

Type TR
Global list:TList = CreateList()
Field player:TP
Field x:Float,y:Float,dx:Float,dy:Float,HP:Float
Field loop:Float,aspeed:Float
Field lastdir:Float

Function Create:TR(player:TP, x:Float, y:Float)
r:TR = New TR
r.player = player
r.dx = Cos(Rand(0,360))*Rand(0,30)
r.dy = Sin(Rand(0,360))*Rand(0,30)
r.x = x+r.dx
r.y = y+r.dy
r.loop = Rand(0,180)
r.aspeed = animspeed*(.8+Rnd()*.2)
r.HP = ratHP
list.AddLast(r)
Return r
End Function

Method up()
loop:+aspeed
If (loop>=180) loop:-180
If (getDist(x,y,player.x+dx,player.y+dy)>mindist)
x :+ Cos(getDir())*player.speed*(Sin(loop)+.3)*speedfactor
y :+ Sin(getDir())*player.speed*(Sin(loop)+.3)*speedfactor
EndIf
If (player.changed)
dx = Cos(Rand(0,360))*Rand(0,30)
dy = Sin(Rand(0,360))*Rand(0,30)
EndIf
attacks=1
For rat:TR=EachIn TR.list
If (attacks=1 And getDist(x,y,rat.x,rat.y)<attD And rat.player<>player)
rat.HP:-player.atk
If (rat.HP<=0 And rat.HP>-1000)
rat.HP=-1001
player.xp:+1
EndIf
attacks=0
EndIf
Next
For base:TB=EachIn TB.list
If (attacks=1 And getDist(x,y,base.x,base.y)<attD And base.owner<>player)
base.HP:-baseattack
If (base.HP<=0)
base.HP=baseHPAfterCap
base.owner=player
player.xp:+5
EndIf
attacks=0
EndIf
Next
End Method
Method getDir:Float()
difx:Float = player.x+dx-x
dify:Float = player.y+dy-y
Return ATan2(dify,difx)
End Method
Method removeIfDead()
If (HP<=0) list.remove(Self)
End Method
Method dr()
SetColor(player.r,player.g,player.b)
DrawOval(x-1,y-1,3,3)
If (getDist(x,y,player.x+dx,player.y+dy)>mindist)
lastdir = getDir()
Else
lastdir:+Rand(-5,5)
EndIf
DrawOval(x-2-Cos(lastdir)*3,y-2-Sin(lastdir)*3,5,5)
DrawLine(x,y,x-Cos(lastdir)*10,y-Sin(lastdir)*10)
End Method
End Type

Function getDist:Float(x1:Float,y1:Float,x2:Float,y2:Float)
x:Float=x2-x1
y:Float=y2-y1
Return Sqr(x*x+y*y)
End Function



Graphics(800,600)

While True
game()
Wend

Function game()
TP.player = TP.Create(1,1,1,0,0,255)
enemy1:TP = TP.Create(1,1,1,255,0,0)
enemy2:TP = TP.Create(1,1,1,0,255,0)
enemy3:TP = TP.Create(1,1,1,255,255,0)

TB.Create(TP.player,100,100)
TB.Create(enemy1,100,500)
TB.Create(enemy2,700,100)
TB.Create(enemy3,700,500)

For i = 1 To Rand(12,16)
TB.Create(Null,Rand(110,690),Rand(110,490))
Next


For i = 1 To 5
TR.Create(TP.player,10,10)
Next

For i = 1 To 5
TR.Create(enemy1,10,590)
Next
For i = 1 To 5
TR.Create(enemy2,790,10)
Next
For i = 1 To 5
TR.Create(enemy3,790,590)
Next

gamerunning=1
outro=0
won=0
While gamerunning=1
If (KeyHit(KEY_ESCAPE)) End
Cls()

If (won=0)
won=checkWon()
ElseIf (outro=0)
TB.list.clear()
For r:TR=EachIn TR.list
If (r.player<>TP.player) TR.list.remove(r)
Next
For i = 1 To 5
TR.Create(TP.player,TP.player.x,TP.player.y)
Next
TB.Create(Null,420,440)
outro=1
EndIf
If (outro=1)
SetScale(10,10)
If (won=1)
DrawText("You Win!",50, 200)
Else
DrawText("You Loose!",50, 200)
EndIf
SetScale(5,5)
DrawText("Restart:",50,400)
SetScale(1,1)
If (checkWon()=1) gamerunning=0
EndIf

For p:TP=EachIn TP.list
p.up()
Next
For b:TB=EachIn TB.list
b.up()
b.dr()
Next
For r:TR=EachIn TR.list
r.up()
r.dr()
Next
For r:TR=EachIn TR.list
r.removeIfDead()
Next 
SetScale(10,10)
DrawText("Level up!", 50, leveluptexty)
leveluptexty:+7
SetScale(1,1)
SetColor(255,255,255)
DrawText("Level: "+TP.player.level,10,10)
Flip(1)
Wend

TB.list.clear()
TP.list.clear()
TR.list.clear()
End Function

Function checkWon()
playerbases=0
totalbases=0
For b:TB=EachIn TB.list
If (b.owner=TP.player) playerbases:+1
totalbases:+1
Next
If (playerbases=0) Return -1
If (playerbases=totalbases) Return 1
Return 0
End Function